%{!?buildid: %{expand: %%define buildid 7}}
%define     vendor_name     oracle
%define     plugin_module   generic
%define     generic_src_dir generic 
%define     generic_files   __init__.py SCSIPlugin.py NFSPlugin.py nfs_linux.py scsi_linux.py 

%define     build_dir       %{_builddir}/%{name}-%{version}
%define     plugin_dir      /opt/storage-connect/plugins
%define     vendor_dir      %{plugin_dir}/%{vendor_name}
%define     install_dir     %{vendor_dir}/%{plugin_module}
%define     sharedoc_dir    /usr/share/doc/%{name}

Name:      osc-%{vendor_name}-%{plugin_module}
Vendor:    Oracle
Version:   3.4.7 
Release: %{buildid}%{?dist}
Summary:   Oracle Storage Connect Generic Plugin
License:   GPLv2
Group:     Oracle/StorageConnect
URL:       http://oss.oracle.com/
Source:    %{name}-%{version}.tar.bz2
BuildArch: noarch
Requires:  python >= 2.7
Requires:  osc-plugin-manager >= 3.4.7

%description
Oracle Storage Connect Generic plugin.

%prep
%setup -q

%build

%install
rm -fr %{buildroot}
install -d -m0755 %{buildroot}/%{install_dir}
install -d -m0755 %{buildroot}/%{sharedoc_dir}
mv %{build_dir}/%{generic_src_dir}/COPYING %{buildroot}/%{sharedoc_dir}/.
rm -fr %{build_dir}/%{sharedoc_dir}
for generic_file in %{generic_files}
do
  mv %{build_dir}/%{generic_src_dir}/${generic_file} %{buildroot}/%{install_dir}/.
done

%clean
rm -fr %{buildroot}

%files
%defattr(0555, root, root, 0755)
%attr(0555, root, root) %{install_dir}/*
%doc %{sharedoc_dir}/*

%%preun
if [ $1 -eq 0 ]
then
    OSC_BIN=/opt/storage-connect/bin
    if [ -x "$OSC_BIN/announce_erase" ]
    then
        $OSC_BIN/announce_erase "%{name}" \
                                "%{version}-%{release}" \
                                "%{install_dir}" \
                                "%{vendor_name}" \
                                "%{plugin_module}"
    fi
    if [ -f %{vendor_dir}/__init__.py ]
    then
        python %{vendor_dir}/__init__.py %{vendor_dir} >/dev/null 2>&1
        if [ "$?" -eq 0 ]
        then
            rm -f %{vendor_dir}/__init__.py
            rm -f %{vendor_dir}/__init__.pyc
            rm -f %{vendor_dir}/__init__.pyo
        fi
    fi
fi
exit 0

%postun
if [ $1 -ge 1 ]
then
    OSC_BIN=/opt/storage-connect/bin
    if [ -x "$OSC_BIN/announce_upgrade" ]
    then
        $OSC_BIN/announce_upgrade "%{name}" \
                                  "%{version}-%{release}" \
                                  "%{install_dir}" \
                                  "%{vendor_name}" \
                                  "%{plugin_module}"
     fi
elif [ $1 -eq 0 ]
then
    rmdir --ignore-fail-on-non-empty %{install_dir}
    rmdir --ignore-fail-on-non-empty %{vendor_dir}
fi
exit 0

%post
OSC_BIN=/opt/storage-connect/bin
if [ -x "$OSC_BIN/announce_install" ]
then
    $OSC_BIN/announce_install "%{name}" \
                              "%{version}-%{release}" \
                              "%{install_dir}" \
                              "%{vendor_name}" \
                              "%{plugin_module}"
fi
if [ ! -f %{vendor_dir}/__init__.py ]
then
    cat >%{vendor_dir}/__init__.py <<__EOF__
#!/usr/bin/env python
"""
@copyright: Copyright (C) 2008, 2010 Oracle.  All rights reserved.

@license:   This program is free software; you can redistribute it and/or
            modify it under the terms of the GNU General Public
            License as published by the Free Software Foundation, version 2.

            This program is distributed in the hope that it will be useful,
            but WITHOUT ANY WARRANTY; without even the implied warranty of
            MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
            General Public License for more details.

            You should have received a copy of the GNU General Public
            License along with this program; if not, write to the Free Software
            Foundation, Inc., 59 Temple Place - Suite 330, Boston,
            MA 021110-1307, USA

@summary:   This is just to enable the import of the plugins.
"""

#
# This is a major hack to get around RPM's limitation of not being able
# to specify the same file for multiple RPM installs
#
# Exit codes:
#   0 : No more dependencies
#   1 : ERROR condition
#   2 : Still have dependencies
#
if __name__ == '__main__':
    import sys
    import os
    if len(sys.argv) <= 1:
        print "ERROR: No vendor dir given!"
        sys.exit(1)

    try:
       vendor_dirs = os.listdir(sys.argv[1])
       ref_count = 0
       for vendor_dir in vendor_dirs:
           vendor_path = os.path.join(sys.argv[1], vendor_dir)
           if os.path.isdir(vendor_path):
               ref_count += 1

    except Exception, e:
        print "ERROR:", e
        sys.exit(1)

    if ref_count > 1:
        sys.exit(2)

    sys.exit(0)

__EOF__
fi
exit 0

%changelog
* Wed Nov 04 2020 Vamsi Krishna Inguva <vamsi.inguva@oracle.com>
- Add ability to build rpm via Makefile, osc-plugin-generic.spec file for OL7U8

* Fri May 28 2010 Joel Becker <joel.becker@oracle.com>
- Initial generic version of this specfile

